#include "main.h"

void Handler(int signo)
{
    // System Exit
    printf("\r\nHandler:exit\r\n");
    DEV_ModuleExit();

    exit(0);
}

int main(void)
{
    signal(SIGINT, Handler);

    float bus_voltage = 0;
    float power = 0;
    float current = 0;
    float P = 0;

    INA219_init();
    while (1)
    {
        bus_voltage = INA219_getBusVoltage_V();     // voltage on V- (load side)
        current = INA219_getCurrent_mA() / 1000;      // current in mA
        power = INA219_getPower_mW() / 1000;        // power in W
        P = (bus_voltage - 3) / 1.2 * 100;
        if (P < 0)
            P = 0;
        else if (P > 100)
            P = 100;

        printf("Voltage:  %6.3f V\r\n", bus_voltage);
        printf("Current:  %6.3f A\r\n", current);
        printf("Power:    %6.3f W\r\n", power);
        printf("Percent:  %6.1f %%\r\n", P);
        Charge_indication();
        printf("\r\n\n");
        DEV_Delay_ms(500);
    }
}
